/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.api.modelstate.primitive;

import org.jetbrains.annotations.ApiStatus.Experimental;
import grondag.fermion.orientation.api.CubeRotation;
import grondag.xm.api.modelstate.base.BaseModelState;
import grondag.xm.api.primitive.simple.Stair;
import net.minecraft.class_2350;
import net.minecraft.class_2465;
import net.minecraft.class_2510;
import net.minecraft.class_2760;
import net.minecraft.class_2778;

@Experimental
public interface PrimitiveState extends BaseModelState<PrimitiveState, MutablePrimitiveState> {
	SimplePrimitiveStateMutator AXIS_FROM_BLOCKSTATE = (modelState, blockState) -> {
		final Comparable<?> axis = blockState.method_11656().get(class_2465.field_11459);

		if (axis != null) {
			modelState.orientationIndex(class_2465.field_11459.method_11902().cast(axis).ordinal());
		}

		return modelState;
	};

	SimplePrimitiveStateMutator STAIRS_FROM_BLOCKSTATE = (modelState, blockState) -> {
		final Comparable<?> faceProp = blockState.method_11656().get(class_2510.field_11571);
		final Comparable<?> half = blockState.method_11656().get(class_2510.field_11572);
		final Comparable<?> shapeProp = blockState.method_11656().get(class_2510.field_11565);

		if (faceProp != null && half != null && shapeProp != null) {
			final class_2778 shape = class_2510.field_11565.method_11902().cast(shapeProp);
			class_2350 face = class_2510.field_11571.method_11902().cast(faceProp);
			final boolean bottom = class_2510.field_11572.method_11902().cast(half) == class_2760.field_12617;
			final boolean corner = shape != class_2778.field_12710;
			boolean inside = false;
			boolean left = false;

			switch (shape) {
				case field_12712:
					left = true;
				case field_12713:
					inside = true;
					break;
				case field_12708:
					left = true;
					break;
				default:
					break;
			}

			if (corner) {
				if (bottom) {
					if (left) {
						face = face.method_10160();
					}
				} else {
					if (!left) {
						face = face.method_10170();
					}
				}
			}

			Stair.setCorner(corner, modelState);
			Stair.setInsideCorner(corner && inside, modelState);
			modelState.orientationIndex(CubeRotation.find(bottom ? class_2350.field_11033 : class_2350.field_11036, face).ordinal());
		}

		return modelState;
	};
}
