/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.dispatch;

import java.util.Collections;
import net.minecraft.class_1087;
import net.minecraft.class_1309;
import net.minecraft.class_1799;
import net.minecraft.class_310;
import net.minecraft.class_638;
import net.minecraft.class_806;
import org.jetbrains.annotations.ApiStatus.Internal;
import org.jetbrains.annotations.Nullable;
import grondag.xm.api.item.XmItem;
import grondag.xm.api.modelstate.MutableModelState;

@Internal
public class ItemOverrideProxy extends class_806 {
	static final ItemOverrideProxy INSTANCE = new ItemOverrideProxy();

	private ItemOverrideProxy() {
		super(null, null, null, Collections.emptyList());
	}

	@Override
	public class_1087 method_3495(class_1087 bakedModel_1, class_1799 stack, @Nullable class_638 world, class_1309 livingEntity_1, int seed) {
		final MutableModelState modelState = XmItem.modelState(world, stack);

		if (modelState != null) {
			final class_1087 result = XmDispatcher.INSTANCE.get(modelState).itemProxy();
			modelState.release();
			return result;
		} else {
			return class_310.method_1551().method_1554().method_4744();
		}
	}
}
