/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.network;

import io.netty.buffer.Unpooled;
import org.jetbrains.annotations.ApiStatus.Internal;
import net.fabricmc.fabric.api.networking.v1.PacketSender;
import net.fabricmc.fabric.api.networking.v1.ServerPlayNetworking;
import net.minecraft.class_2540;
import net.minecraft.class_2596;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_634;
import grondag.xm.Xm;
import grondag.xm.api.paint.XmPaint;
import grondag.xm.paint.PaintIndexImpl;

@Internal
public abstract class PaintIndexSnapshotS2C {
	private PaintIndexSnapshotS2C() { }

	public static final class_2960 ID = new class_2960(Xm.MODID, "pxs");

	public static class_2596<?> toPacket(PaintIndexImpl paintIndex) {
		final class_2540 pBuff = new class_2540(Unpooled.buffer());
		paintIndex.toBytes(pBuff);
		return ServerPlayNetworking.createS2CPacket(ID, pBuff);
	}

	public static void accept(class_310 client, class_634 handler, class_2540 pBuff, PacketSender responseSender) {
		final XmPaint[] paints = PaintIndexImpl.arrayFromBytes(pBuff);

		if (client.method_18854()) {
			PaintIndexImpl.CLIENT.fromArray(paints);
		} else {
			client.execute(() -> PaintIndexImpl.CLIENT.fromArray(paints));
		}
	}
}
