/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.paint;

import org.jetbrains.annotations.ApiStatus.Internal;

import com.mojang.serialization.Lifecycle;
import grondag.xm.Xm;
import grondag.xm.api.paint.VertexProcessor;
import grondag.xm.api.paint.VertexProcessorRegistry;
import net.minecraft.class_2348;
import net.minecraft.class_2378;
import net.minecraft.class_2385;
import net.minecraft.class_2960;
import net.minecraft.class_5321;

@Internal
@SuppressWarnings({ "unchecked", "rawtypes" })
public class VertexProcessorRegistryImpl extends class_2348<VertexProcessor> implements VertexProcessorRegistry {
	public static final VertexProcessor DEFAULT_VERTEX_PROCESSOR = VertexProcessorDefault.INSTANCE;

	private static final class_5321 REGISTRY_KEY = class_5321.method_29180(Xm.id("vertex_proc"));
	public static final VertexProcessorRegistryImpl INSTANCE;

	static {
		INSTANCE = (VertexProcessorRegistryImpl) ((class_2385) class_2378.field_11144).method_10272(REGISTRY_KEY,
				new VertexProcessorRegistryImpl(NONE_ID.toString()), Lifecycle.stable());
	}

	VertexProcessorRegistryImpl(String defaultIdString) {
		super(defaultIdString, REGISTRY_KEY, Lifecycle.experimental());
	}

	@Override
	public VertexProcessor add(class_2960 id, VertexProcessor processor) {
		return class_2378.method_10230(this, id, processor);
	}

	@Override
	public VertexProcessor get(int index) {
		return method_10200(index);
	}
}
